//------------------------------------------------------------------------
//DirectSoundNX
//------------------------------------------------------------------------
#include "stdafx.h"
#include "VixarLibrary.h"

//------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------
CDirectSound::CDirectSound()
{
	m_lpDS = NULL;
	m_lpPrimary = NULL;
	for ( int i = 0; i < SOUND_MAX; i++ )
	{
		m_lpSecondary[i] = NULL;
	}
}

//------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------
CDirectSound::~CDirectSound()
{
	Release();
}

//------------------------------------------------------------------------
//DirectSound
//------------------------------------------------------------------------
BOOL CDirectSound::Init(HWND hWnd)
{
	HRESULT ret;

	// DirectSound8쐬
	ret = DirectSoundCreate8( NULL,&m_lpDS,NULL );
	if( FAILED(ret) ) {
		//TEhIuWFNg쐬s
		return FALSE;
	}

	// [h
	ret = m_lpDS->SetCooperativeLevel( hWnd,DSSCL_EXCLUSIVE|DSSCL_PRIORITY );
	if( FAILED(ret) ) {
		//xݒ莸s
		return FALSE;
	}

	// vC}TEhobt@
	if( !CreatePrimaryBuffer() )
	{
		//vC}TEhobt@s
		return FALSE;
	}

	return TRUE;
}

//------------------------------------------------------------------------
//vC}TEhobt@̍쐬
//------------------------------------------------------------------------
BOOL CDirectSound::CreatePrimaryBuffer( void )
{
	HRESULT ret;
	WAVEFORMATEX wf;

	// vC}TEhobt@̍쐬
	DSBUFFERDESC dsdesc;
	ZeroMemory( &dsdesc,sizeof(DSBUFFERDESC) );
	dsdesc.dwSize = sizeof( DSBUFFERDESC );
	dsdesc.dwFlags = DSBCAPS_PRIMARYBUFFER;
	dsdesc.dwBufferBytes = 0;
	dsdesc.lpwfxFormat = NULL;
	ret = m_lpDS->CreateSoundBuffer( &dsdesc,&m_lpPrimary,NULL );
	if( FAILED(ret) ) {
		//vC}TEhobt@쐬s
		return FALSE;
	}

	// vC}obt@̃Xe[^X
	wf.cbSize = sizeof( WAVEFORMATEX );
	wf.wFormatTag = WAVE_FORMAT_PCM;
	wf.nChannels = 2;
	wf.nSamplesPerSec = 44100;
	wf.wBitsPerSample = 16;
	wf.nBlockAlign = wf.nChannels * wf.wBitsPerSample / 8;
	wf.nAvgBytesPerSec = wf.nSamplesPerSec * wf.nBlockAlign;
	ret = m_lpPrimary->SetFormat( &wf );
	if( FAILED(ret) ) {
		//vC}obt@̃Xe[^Xs
		return FALSE;
	}
	return TRUE;
}

//------------------------------------------------------------------------
//WAVTEht@C̓ǂݍ
//------------------------------------------------------------------------
BOOL CDirectSound::LoadSound(int sound, char *fileName )
{
	HRESULT ret;
	MMCKINFO mSrcWaveFile;
	MMCKINFO mSrcWaveFmt;
	MMCKINFO mSrcWaveData;
	LPWAVEFORMATEX wf;

	// WAVt@C[h
	HMMIO hSrc;
	char file[256];
	sprintf(file,"%s%s",GetDirectory(),fileName);
	hSrc = mmioOpen( file,NULL,MMIO_ALLOCBUF|MMIO_READ|MMIO_COMPAT );
	if( !hSrc ) {
		//WAVt@C[hG[
		return FALSE;
	}

	// 'WAVE'`N`FbN
	ZeroMemory( &mSrcWaveFile,sizeof(mSrcWaveFile) );
	ret = mmioDescend( hSrc,&mSrcWaveFile,NULL,MMIO_FINDRIFF );
	if( mSrcWaveFile.fccType!=mmioFOURCC('W','A','V','E') ) {
		//WAVE`N`FbNG[
		mmioClose( hSrc,0 );
		return FALSE;
	}

	// 'fmt '`N`FbN
	ZeroMemory( &mSrcWaveFmt,sizeof(mSrcWaveFmt) );
	ret = mmioDescend( hSrc,&mSrcWaveFmt,&mSrcWaveFile,MMIO_FINDCHUNK );
	if( mSrcWaveFmt.ckid!=mmioFOURCC('f','m','t',' ') ) {
		//fmt `N`FbNG[
		mmioClose( hSrc,0 );
		return FALSE;
	}

	// wb_TCY̌vZ
	int iSrcHeaderSize = mSrcWaveFmt.cksize;
	if( iSrcHeaderSize<sizeof(WAVEFORMATEX) )
		iSrcHeaderSize=sizeof(WAVEFORMATEX);

	// wb_m
	wf = (LPWAVEFORMATEX)malloc( iSrcHeaderSize );
	if( !wf ) {
		//mۃG[
		mmioClose( hSrc,0 );
		return FALSE;
	}
	ZeroMemory( wf,iSrcHeaderSize );

	// WAVEtH[}bg̃[h
	ret = mmioRead( hSrc,(char*)wf,mSrcWaveFmt.cksize );
	if( FAILED(ret) ) {
		//WAVEtH[}bg[hG[
		free( wf );
		mmioClose( hSrc,0 );
		return FALSE;
	}

	// fmt`Nɖ߂
	mmioAscend( hSrc,&mSrcWaveFmt,0 );

	// data`NT
	while(1) {
		// 
		ret = mmioDescend( hSrc,&mSrcWaveData,&mSrcWaveFile,0 );
		if( FAILED(ret) ) {
			//data`NȂ
			free( wf );
			mmioClose( hSrc,0 );
			return FALSE;
		}
		if( mSrcWaveData.ckid==mmioStringToFOURCC("data",0) )
			break;
		// ̃`N
		ret = mmioAscend( hSrc,&mSrcWaveData,0 );
	}

	// TEhobt@̍쐬
	DSBUFFERDESC dsdesc;
	ZeroMemory( &dsdesc,sizeof(DSBUFFERDESC) );
	dsdesc.dwSize = sizeof( DSBUFFERDESC );
	dsdesc.dwFlags = DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_STATIC | DSBCAPS_LOCDEFER;
	dsdesc.dwBufferBytes = mSrcWaveData.cksize;
	dsdesc.lpwfxFormat = wf;
	dsdesc.guid3DAlgorithm = DS3DALG_DEFAULT;
	ret = m_lpDS->CreateSoundBuffer( &dsdesc,&m_lpSecondary[sound],NULL );
	if( FAILED(ret) ) {
		//TEhobt@̍쐬G[
		free( wf );
		mmioClose( hSrc,0 );
		return FALSE;
	}

	// bNJn
	LPVOID pMem1,pMem2;
	DWORD dwSize1,dwSize2;
	ret = (*&m_lpSecondary[sound])->Lock( 0,mSrcWaveData.cksize,&pMem1,&dwSize1,&pMem2,&dwSize2,0 );
	if( FAILED(ret) ) {
		//bNs
		free( wf );
		mmioClose( hSrc,0 );
		return FALSE;
	}

	// f[^
	mmioRead( hSrc,(char*)pMem1,dwSize1 );
	mmioRead( hSrc,(char*)pMem2,dwSize2 );

	// bN
	(*&m_lpSecondary[sound])->Unlock( pMem1,dwSize1,pMem2,dwSize2 );

	// wb_pJ
	free( wf );

	// WAV
	mmioClose( hSrc,0 );

	return TRUE;
}

//------------------------------------------------------------------------
//Đ
//------------------------------------------------------------------------
void CDirectSound::Play(int sound,BOOL loop)
{
	m_lpSecondary[sound]->Play( 0,0,loop?DSBPLAY_LOOPING:0 );
}

//------------------------------------------------------------------------
//~
//------------------------------------------------------------------------
void CDirectSound::Stop(int sound)
{
	m_lpSecondary[sound]->Stop();
}

//------------------------------------------------------------------------
//Đʒuw
//------------------------------------------------------------------------
void CDirectSound::SetCurrentPosition(int sound,int pos)
{
	m_lpSecondary[sound]->SetCurrentPosition(pos);
}

//------------------------------------------------------------------------
//
//------------------------------------------------------------------------
BOOL CDirectSound::Release( void )
{
	for ( int i = 0; i < SOUND_MAX; i++ )
	{
		SAFE_RELEASE(m_lpSecondary[i]);
	}
	SAFE_RELEASE(m_lpPrimary) ;
	SAFE_RELEASE(m_lpDS);

	return TRUE;
}
