//------------------------------------------------------------------------
//DirectXGraphics.cpp	
//------------------------------------------------------------------------
#include "stdafx.h"
#include "VixarLibrary.h"

//------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------
CDirectXGraphics::CDirectXGraphics()
{
}

//------------------------------------------------------------------------
//CDirectXGraphicsRXgN^	
//------------------------------------------------------------------------
CDirectXGraphics::CDirectXGraphics(HWND hWnd,bool window,int width,int height)
{
	m_pD3D = NULL;
	m_pD3DDevice = NULL;

	// Direct3DIuWFNg쐬
	m_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!m_pD3D)
	{
		//Direct3D̍쐬Ɏs
		return;
	}
	// gpA_v^ԍ
	m_adapter = 0;
	// Direct3D 
	D3DDISPLAYMODE disp;
	ZeroMemory(&m_d3dpp,sizeof(D3DPRESENT_PARAMETERS));
	// ݂̉ʃ[h擾
	m_pD3D->GetAdapterDisplayMode(m_adapter,&disp);
	// EChE : ݂̉ʃ[hgp
	m_d3dpp.BackBufferFormat = disp.Format;
	// \̈TCY̐ݒ
	m_d3dpp.BackBufferWidth = width;
	m_d3dpp.BackBufferHeight = height;
	m_width = (float)width;
	m_height = (float)height;
	m_d3dpp.SwapEffect = D3DSWAPEFFECT_FLIP;
	// EChE[h
	m_d3dpp.Windowed = window;
	// Z obt@̎쐬
	m_d3dpp.EnableAutoDepthStencil = 1;
	m_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	// foCX̍쐬 - T&L HAL
	if (FAILED(m_pD3D->CreateDevice(m_adapter,D3DDEVTYPE_HAL,hWnd,D3DCREATE_HARDWARE_VERTEXPROCESSING,&m_d3dpp,&m_pD3DDevice)))
	{
		// ŝ HAL Ŏs
		if (FAILED(m_pD3D->CreateDevice(m_adapter,D3DDEVTYPE_HAL,hWnd,D3DCREATE_SOFTWARE_VERTEXPROCESSING,&m_d3dpp,&m_pD3DDevice)))
		{
			//Direct3DfoCX̍쐬Ɏs
			return;
		}
	}

	//wiFݒ
	SetBgColor(30, 65, 90);

	//XvCg̍쐬
	CreateSprite();

	return;
}

//------------------------------------------------------------------------
//CDirectXGraphicsfXgN^
//------------------------------------------------------------------------
CDirectXGraphics::~CDirectXGraphics()
{
	//XvCg
    SAFE_RELEASE(m_pSprite);
	// Direct3DfoCX
	SAFE_RELEASE(m_pD3DDevice);
	//Direct3D
	SAFE_RELEASE(m_pD3D);
}

//------------------------------------------------------------------------
//CDirectXGraphics::Init
//------------------------------------------------------------------------
void CDirectXGraphics::SetBgColor(int r,int g,int b)
{
	// wiF̏ݒ
	m_bgColor = D3DCOLOR_XRGB(r,g,b);
}

//------------------------------------------------------------------------
//ʃTCYύXꂽƂ
//------------------------------------------------------------------------
void CDirectXGraphics::OnSize(int cx, int cy)
{
	if ( cx > 0 && cy > 0 )
	{
		//
		m_width = (float)cx;
		//
		m_height = (float)cy;
		//
		m_d3dpp.BackBufferWidth  = cx;
		//
		m_d3dpp.BackBufferHeight = cy;
		//Zbg
		if( FAILED( m_pD3DDevice->Reset( &m_d3dpp ) ) )
		{
			//TCYɎs
			return;
		}
	}
}

//------------------------------------------------------------------------
//DirectX̕`Jn
//------------------------------------------------------------------------
void CDirectXGraphics::BeginRendering(float nearZ,float farZ,float fov)
{
	D3DXMATRIX matProj;

	// obNobt@Zobt@NA
	m_pD3DDevice->Clear(0,NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,m_bgColor,1.0f,0);

	// `Jn
	m_pD3DDevice->BeginScene();

	// _OEXe[gݒ
	// Z obt@L
	m_pD3DDevice->SetRenderState(D3DRS_ZENABLE,TRUE);
	// @xNg̐K
	m_pD3DDevice->SetRenderState(D3DRS_NORMALIZENORMALS,TRUE);
	// At@ufBOL
	m_pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE,TRUE);
	m_pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
	m_pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	// |S̕Жʂ`
	m_pD3DDevice->SetRenderState(D3DRS_CULLMODE,D3DCULL_CCW);
	// _O̐F̌vZ@̐ݒ
	m_pD3DDevice->SetTextureStageState(0,D3DTSS_COLOROP,D3DTOP_MODULATE);
	// _̐Fgp
	m_pD3DDevice->SetTextureStageState(0,D3DTSS_COLORARG2,D3DTA_DIFFUSE);
	m_pD3DDevice->SetTextureStageState(0,D3DTSS_ALPHAARG2,D3DTA_DIFFUSE);
	// eNX`̐Fgp
	m_pD3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
	m_pD3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	m_pD3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
	m_pD3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_MODULATE );
	m_pD3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
	m_pD3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );
	m_pD3DDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
	m_pD3DDevice->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
	// CgL
	m_pD3DDevice->LightEnable(0,TRUE);
	m_pD3DDevice->SetRenderState(D3DRS_LIGHTING,TRUE);
	m_pD3DDevice->SetRenderState(D3DRS_AMBIENT,D3DCOLOR_XRGB(255,255,255));
	m_pD3DDevice->SetRenderState(D3DRS_SPECULARENABLE,TRUE); 
	m_pD3DDevice->SetRenderState(D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_MATERIAL);
	m_pD3DDevice->SetRenderState(D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL);
	m_pD3DDevice->SetRenderState(D3DRS_AMBIENTMATERIALSOURCE, D3DMCS_MATERIAL);
	m_pD3DDevice->SetRenderState(D3DRS_EMISSIVEMATERIALSOURCE, D3DMCS_MATERIAL);
	m_pD3DDevice->SetRenderState(D3DRS_LOCALVIEWER,FALSE);
	// _tH[}bgݒ
	m_pD3DDevice->SetFVF(FVF_NVERTEX);
	// X[YEVF[fBO
	m_pD3DDevice->SetRenderState(D3DRS_SHADEMODE,D3DSHADE_GOURAUD);
	// vWFNVsݒ
	// E 10 xA߂̌E nearǍE far
	D3DXMatrixPerspectiveFovRH(&matProj,D3DXToRadian(fov),m_width/m_height,nearZ,farZ);
	// esݒ
	m_pD3DDevice->SetTransform(D3DTS_PROJECTION,&matProj);
}

//------------------------------------------------------------------------
//J̃Zbg	
//------------------------------------------------------------------------
void CDirectXGraphics::SetCamera(D3DXVECTOR3 eye,D3DXVECTOR3 at)
{
	D3DXMATRIX matView;
	// r[sݒ
	D3DXMatrixLookAtRH(&matView,&eye,&at,&D3DXVECTOR3(0,1,0));
	//r[sZbg
	m_pD3DDevice->SetTransform(D3DTS_VIEW,&matView);
}

//------------------------------------------------------------------------
//Cg	
//------------------------------------------------------------------------
void CDirectXGraphics::SetLight(D3DXVECTOR3 dir)
{
    ZeroMemory( &m_light, sizeof(D3DLIGHT9) );
    m_light.Type	   = D3DLIGHT_DIRECTIONAL;
	m_light.Ambient.r  = 0.2f;
	m_light.Ambient.g  = 0.2f;
	m_light.Ambient.b  = 0.2f;
	m_light.Ambient.a  = 1.0f;
    m_light.Diffuse.r  = 0.8f;
    m_light.Diffuse.g  = 0.8f;
    m_light.Diffuse.b  = 0.8f;
    m_light.Diffuse.a  = 1.0f;
	m_light.Specular.r = 0.8f;
	m_light.Specular.g = 0.8f;
	m_light.Specular.b = 0.8f;
	m_light.Specular.a = 1.0f;
//	m_light.Position   = D3DXVECTOR3(0,0,3000);
	m_light.Falloff    = 1.0f;
	m_light.Theta      = 0.0f;
	m_light.Phi        = D3DX_PI;
	m_light.Range      = 10000.0f;
	m_light.Direction  = -dir;

	m_pD3DDevice->SetLight(0,&m_light);
}

//------------------------------------------------------------------------
//DirectX̕`I	
//------------------------------------------------------------------------
void CDirectXGraphics::EndRendering()
{
	// `I
	m_pD3DDevice->EndScene();

	// obNobt@vC}obt@ɃRs[
	if (FAILED(m_pD3DDevice->Present(NULL,NULL,NULL,NULL)))
	{
		//Zbg
		m_pD3DDevice->Reset(&m_d3dpp);
	}
}

//------------------------------------------------------------------------
//Zobt@NA
//------------------------------------------------------------------------
void CDirectXGraphics::ClearZBuffer()
{
	m_pD3DDevice->Clear(0,NULL, D3DCLEAR_ZBUFFER,NULL,1.0f,0);
}

//------------------------------------------------------------------------
//XvCg̍쐬
//------------------------------------------------------------------------
BOOL CDirectXGraphics::CreateSprite()
{
    HRESULT hr;
    //XvCg̍쐬
    hr = D3DXCreateSprite(m_pD3DDevice,&m_pSprite);
    
    //XvCg쐬łȂ烁bZ[W{bNX   
    if (FAILED(hr))
	{
        return FALSE;
    }

	return TRUE;
}

//------------------------------------------------------------------------
//XvCg̕`Jn
//------------------------------------------------------------------------
void CDirectXGraphics::BeginSprite()
{
	//XvCg̕`Jn
	m_pSprite->Begin(D3DXSPRITE_SORT_DEPTH_BACKTOFRONT);
}

//------------------------------------------------------------------------
//XvCg̕`I
//------------------------------------------------------------------------
void CDirectXGraphics::EndSprite()
{
	//XvCg̕`I
    m_pSprite->End();
}

//------------------------------------------------------------------------
//tHg̍쐬
//------------------------------------------------------------------------
BOOL CDirectXGraphics::CreateFont(LPD3DXFONT *ppFont,int w,int h,bool bold,std::string font)
{
	HRESULT	hr;

	hr = D3DXCreateFont(
		m_pD3DDevice,
		w,
		h,
		(bold)?FW_BOLD:FW_REGULAR,
		0,
		FALSE,
		SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS,
		DEFAULT_QUALITY,
		DEFAULT_PITCH || FF_DONTCARE,
		font.c_str(),
		ppFont);

	if ( FAILED(hr) )
	{
		return FALSE;
	}

	return TRUE;
}

//------------------------------------------------------------------------
//tHg̕`
//------------------------------------------------------------------------
void CDirectXGraphics::DrawText(
	ID3DXFont* pFont,std::string text,int left,int top,int right,int bottom,DWORD format,D3DCOLOR color)
{
	RECT rect;
	rect.left = left;
	rect.top = top;
	rect.right = right;
	rect.bottom = bottom;
	pFont->DrawText(m_pSprite,text.c_str(), -1,&rect,format,color);
}

//------------------------------------------------------------------------
//Direct3DfoCX̎擾
//------------------------------------------------------------------------
LPDIRECT3DDEVICE9 CDirectXGraphics::GetD3DDevice()
{
	return m_pD3DDevice;
}

//------------------------------------------------------------------------
//XvCg擾
//------------------------------------------------------------------------
LPD3DXSPRITE CDirectXGraphics::GetSprite()
{
	return m_pSprite;
}

//------------------------------------------------------------------------
//_eye猩ړInat̕WAŕԂ
//------------------------------------------------------------------------
float GetDirRadian(D3DXVECTOR3 eye, D3DXVECTOR3 at)
{
    float radian;
    D3DXVECTOR3 dir = eye - at;

    if (dir.x < 0.0f)
    {
        radian = (float)(-atan(dir.z / dir.x) + D3DX_PI / 2);
    }
    else if (dir.x > 0.0f)
    {
        radian = (float)(-atan(dir.z / dir.x) - D3DX_PI / 2);
    }
    else
    {
        radian = (float)(-atan(dir.z) - D3DX_PI / 2);
    }

	return radian;
}

//------------------------------------------------------------------------
//_eye猩ړInat̕fBO[ŕԂ
//------------------------------------------------------------------------
float GetDirDegree(D3DXVECTOR3 eye, D3DXVECTOR3 at)
{
    float degree = D3DXToDegree(GetDirRadian(eye, at));

    if (degree < 0)
	{
		degree += 360;
	}
	if (degree >= 360)
	{
		degree -= 360;
	}

	return degree;
}

//------------------------------------------------------------------------
//vÔfBNg擾
//------------------------------------------------------------------------
char* GetDirectory(void)
{
	static int i;
	static char Buffer[256];

	// JgfBNgB̎擾
	GetModuleFileName(NULL,(LPCH)Buffer,256);

	for (i=(int)strlen(Buffer);Buffer[i]!='\\';i--)
	{
		Buffer[i]=NULL;
	}

	return Buffer;
}

//------------------------------------------------------------------------
//l󂯎ľܓlԂ
//------------------------------------------------------------------------
int round(float value)
{
	int i = (int)(value);
	float f = value - i;

	return (f < 0.5f)?i:(i+1);
}

//------------------------------------------------------------------------
//xNgƑOxNgpsԂ
//------------------------------------------------------------------------
D3DXMATRIX GetPosture(D3DXVECTOR3* vecUpper,D3DXVECTOR3* vecFront)
{
	D3DXMATRIX matrix;
	D3DXVECTOR3 vec;
	D3DXVECTOR3 vecRight;

	D3DXVec3Cross(&vec,vecUpper,vecFront);
	D3DXVec3Normalize(&vecRight,&vec);
	D3DXVec3Cross(&vec,&vecRight,vecUpper);
	D3DXVec3Normalize(vecFront,&vec);

	matrix._11 = vecRight.x;
	matrix._12 = vecRight.y;
	matrix._13 = vecRight.z;
	matrix._14 = 0;
	matrix._21 = vecUpper->x;
	matrix._22 = vecUpper->y;
	matrix._23 = vecUpper->z;
	matrix._24 = 0;
	matrix._31 = vecFront->x;
	matrix._32 = vecFront->y;
	matrix._33 = vecFront->z;
	matrix._34 = 0;
	matrix._41 = 0;
	matrix._42 = 0;
	matrix._43 = 0;
	matrix._44 = 1;

	return matrix;
}
